catch {formatTextBase destroy}

package provide formatTextWin 1.0

# A base class for customizable text widgets
# Handles cmd line parsing and building/positioning the toplevel
# windows.
# 
# This class may used directly for a text widget with extended
# configuration options.
#
# It can be used as a superclass for widgets that import/export
# to non-native formats.
# 
# A classmethod unknown (boilerplate), constructor 
# must be defined by the derived class to place elements in
# the appropriate frames.
# OR
# A helper proc must call a "derivedClass new" method.
#
# See the sample/example in the -testTOO section for
# details.

# Color icons for the Foreground/Background pulldowns

image create photo icon-red,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAG9JREFUOI3tk0sOgCAMRB+Gs8j9jzNcpi4UI58Eoiw0cZJuynQ6Da2TZBzw
AGsIACxc4BLNGVj+LMkMssiKK5EzkcQSqrJ+otl+yE5f+i6pGrRJKocvEaWJnj5L
GvrgXkgaW4J5tn+hdwl52G/qKTaTS1/cvbbCbQAAAABJRU5ErkJggg==
}
image create photo icon-orange,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAGtJREFUOI3tk8sNgDAMQx3UWWABVmYbFjDLhAtB9KfkAgKJd0xtN0lVIak4
SAAwrhMAYMAFMZnoAs2OhaSaycjMVchZsLCuzS80r3dd94qqQZuicviSbebTjb9R
FHpgj/AuI/xBXwwKfcoIOwIPLKns6WF4AAAAAElFTkSuQmCC
}
image create photo icon-yellow,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAHBJREFUOI3tk0sOgCAMRB+Gs+D9jzNcpi4UI58Eoiw0cZJuynQ6Da2TZBzw
ACGsACxc4BLNmWH5syQzI4usuBI5E0ksoSrrJ5rth+z0pe+SqkGbpHL4EjFqoqfP
koY+uBeSxpZgnu1f6F1CHvabeooN7Xt+voei2EUAAAAASUVORK5CYII=
}
image create photo icon-green,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAGpJREFUOI3tk8sNgDAMQ18QuzAT27ANM3maciGIflBzAYHEO6a2m6SqSUrs
jADTOgEwcMJcZiyk7NgkJTc5mbkKOQoedmnrF5rXd133iqpBm6Jy+BLNerrxN4pC
D9wjvMsIf9AXg0KfMsIGHmUo9T5vVrYAAAAASUVORK5CYII=
}
image create photo icon-blue,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAG9JREFUOI3tk0sOgCAMRB+Gs8j9jzNepi4QI58Eoiw0cZJu2ukwDa2TZBzw
ACGsACxc4BLNgVlejiXLImuuRM5EEkuo2vqJ5vNDdvrSd0nVoE1SOXwJaZvo6bOk
oQ/uhaSxJZhn+xd6l5CHeFNPsQNVh1/cywoaPAAAAABJRU5ErkJggg==
}
image create photo icon-violet,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAGVJREFUOI1jvHnz5n8GKGBhYGBgEF0pysDAwMDAxIAEGGHKWDCkGW/evPkf
JgoDKJoxDIHbR1AbYQGs1hPURVtFGB7FBjA8jw5eh7+mt8MHoyKiIpgQIDosiQGj
Bg1Fg4jKlMQAAM1AJraYlohdAAAAAElFTkSuQmCC
}
image create photo icon-black,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAGxJREFUOI3tk1EKwCAMQ5/Du/T+x8lp3Md0rCoomx8bLNCfNo0ptkFSIiMC
mBkAGxeEQgtA8uVccuGaG5EzUcQKmrZxovv8lJ2x9F1SM2iXRDV8DUkLPX2WNPXB
o5A0twTrbP9C7xKKcNzUU+waOUD6oLY1ggAAAABJRU5ErkJggg==
}
image create photo icon-white,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAG1JREFUOI3tk0sOgCAMRB+Gs3D/6wyXKQvFyCeBKAtNfMsyHaYpOEnGgQcI
IQCwccFlmTMzK48lWU3R3JichWyWadrGhe71U3HG1ndFzaBdUT18TYxxYabPiqYW
PELS3CNYF/s3epeRh/1PPSUBKNidoHDA/N4AAAAASUVORK5CYII=
}
image create photo icon-gray,16 -data {
iVBORw0KGgoAAAANSUhEUgAAABIAAAASCAYAAAEhyb7BAAAABGdBTUEAAYagMeiW
XwAAAGNJREFUOI3tk1EOgDAIQ4vZJTkhZ+ppth8xKkvgZ0YT3ydrC2yZkOzYaQBg
ZgCADSfEZS0cC8nuVediDiFHv9SWF6btU9daUVh0Rlj+jqo+PfgbRaUHzijfZYU/
6ItBpU9ZYQCdfCxgLDXECwAAAABJRU5ErkJggg==
}

# Only define this if it's not already defined by a previous source.
if {[info command formatTextOO] eq ""} {

# Create the classmethod proc if it's not already defined.
if {[info proc ::oo::define::classmethod] eq ""} {
  proc ::oo::define::classmethod {name {args ""} {body ""}} {
     # Create the method on the class if the caller gave
     # arguments and body
     if {[llength [info level 0]] == 4} {
          uplevel 1 [list self method $name $args $body]
     }
     # Get the name of the class being defined
     set cls [lindex [info level -1] 1]
     # Make connection to private class "my" command by
     # forwarding
     uplevel forward $name [info object namespace $cls]::my $name
  }
}

# Base class to be superclass'd by real classes

oo::class create formatTextWin {
  variable State

# CONFIGURATION OPTIONS
# -controlFrame 	Where to build the control frame. The default
#    is an empty string, which will make the control frame a sibling
#    to the text window. This can be a separate frame of toplevel.
#
# -controlStyle Layout style for control frame. 
#    May be block, row or column
#
# -cmdDict - Dictionary of label to display and info for
#    GenerateTagConfig to use to configure the tag.
#    Default is:
#          i {italic}
#          b {bold}
#	  _ {-underline true}
#	  - {-overstrike true}
#
# -foreground Text color, Default black. Modified by control panel
#
# -background background color. Default white. Modified by control panel
#
# -fontSize  Default 12 Modified by control panel
#
# -fontFamily Default arial Modified by control panel

################################################################
#   classmethod unknown {w args}--
#    Handles unknown event
# Arguments
#  w	First argument to unknown. Hopefully a window name
#  args	Everything else
#
# Results
#   If w is a window name, control is passed to class create method
#   and a new widget is created.
# 
  classmethod unknown {w args} {
    if {[string match .* $w]} {
      set newObj [[self] new $w {*}$args]
#      rename $w ${w}_WIN
      return $newObj
    }
    next $w {*}$args
  }

  # For debugging
  method parray {{varName  State}} {
    parray $varName
  }

  # Set up the basics, parse cmd line args

################################################################
#   constructor {top args}--
#    Create the object and associated widgets
# Arguments
#  top	toplevel widget 
#  args	Everything else: -option value pairs
# Results
#   New widget is created. Other frames in calling program
#   may be modified depending on args.
# 
  constructor {top args} {
    variable State
    variable image
    global env
    array set State {
      tagNum 1
      fontSize   12
      fontFamily arial
      families {serif sans-serif courier}
      controlStyle block
      cmdDict {
          i {italic}
          b {bold}
	  _ {-underline true}
	  - {-overstrike true}
	  }
    
      controlFrame {}
      rangeStart 1.0
      rangeEnd 1.0
      prevRange ""
      gridrow 0
      gridcol 0
      gridcnt 0
      colorList {icon-red,16 icon-orange,16 icon-yellow,16 icon-green,16 
      icon-blue,16 icon-violet,16 icon-black,16 icon-white,16 icon-gray,16}
      foreground black
      background white
    }
    
    foreach {k v} $args {
      my configure $k $v
    }
    # parray State
    
    set State(textWin) [text $top]

    bind $State(textWin) <KeyRelease>    "[self] keyRelease %A; break;"
    bind $State(textWin) <ButtonRelease> "+[self] buttonRelease %x %y"

    # Default to making the control block a frame within the parent.
    if {$State(controlFrame) eq ""} {
      set prnt [winfo parent $top]
      if {$prnt eq "."} {set prnt ""}
      set State(controlFrame) [frame $prnt.formattedTextcontrolFrame]
    }

    set State(cmdCount) [llength [dict keys $State(cmdDict)]]

    foreach fmt  [dict keys $State(cmdDict)] {
      set State($fmt) 0
      set w [checkbutton $State(controlFrame).$fmt -text $fmt \
          -padx 3 -pady 1 -indicatoron 0 \
	  -variable [my varname State($fmt)] \
          -command [list [self] setTag]]
      my GridWidget $w
    }

    ttk::combobox $State(controlFrame).family -values $State(families) \
        -textvariable [my varname State(fontFamily)] -width 8 \
	-state readonly

    trace add variable [my varname State(fontFamily)] write "[self] setTag"
    my GridWidget $State(controlFrame).family

    set ff2 [frame $State(controlFrame).sizeColor]
    set State(colorFontFrame) $ff2

    ttk::combobox $ff2.fontSize -values {8 10 12 14 16 18 20 24} \
        -textvariable [my varname State(fontSize)] -width 3 \
	-state readonly

    trace add variable [my varname State(fontSize)] write "[self] setTag"
    
    grid $ff2.fontSize -row 0 -column 0

    menubutton $ff2.fg -image icon-$State(foreground),16 \
        -menu $ff2.fg.m
    set m [menu $ff2.fg.m]
    foreach color $State(colorList) {
      lassign [split $color -,] i clr s
      $m add radiobutton -image $color -value $clr \
          -variable [my varname State(foreground)]
    }
    trace add variable [my varname State(foreground)] write "[self] setTag"
    grid $ff2.fg -row 0 -column 1

    menubutton $ff2.bg -image icon-$State(background),16 \
        -menu $ff2.bg.m
    set m [menu $ff2.bg.m]
    foreach color $State(colorList) {
      lassign [split $color -,] i clr s
      $m add radiobutton -image $color -value $clr \
          -variable [my varname State(background)]
    }
    trace add variable [my varname State(background)] write "[self] setTag"
    grid $ff2.bg -row 0 -column 2
    my GridWidget $ff2

    my GenerateTagConfig
    # puts "SELF: [self]"
    return [self]
  }

################################################################
#   destructor--
#    Get me out of here
# Arguments
#   NONE
# 
# Results
#   Object and associated widgets are destroyed
# 
  destructor {
    variable State
    catch {destroy $State(textWin)}
    catch {destroy $State(controlFrame)}
  }

  ################################################################
  #   method configure {{key ""} {value NoSuChVaLuE}}--
  #    Access the State variable
  #    
  # Arguments
  #   key		An index into the State array
  #   value	A value to assign to the index variable
  #   If both are blank, return all key/value pairs
  #   If only key is set, return current value of key
  #   If both are set, assign a value to the key.
  # Results
  #   State may be modified.  No external side effects

  method configure {{key ""} {value NoSuChVaLuE}} {
    variable State
    
    if {$key eq ""} {
      return [array get State]
    }
    # Get rid of any possible preceeding -
    set key [string trimleft $key {-}]
  
    if {[string equal $value "NoSuChVaLuE"]} {
      if {[info exists State($key)]} {
        return $State($key)
      } else {
        return ""
      }
    }
    set State($key) $value
    return $value
  }
  
################################################################
#   method GridWidget {widgetName}--
#    Internal method to grid the control frame widgets
# Arguments
#   widgetName	The name of the widget to grid
# 
# Results
#   New widget is added to State(controlFrame)
#   Location depends on layout method - block, row or column
# 
  method GridWidget {widgetName} {
    variable State
puts "WIDGETNAME: $widgetName"
      set colspan 1
      switch $State(controlStyle) {
        block {
 	  set State(gridrow) [expr {$State(gridcnt) % int(sqrt($State(cmdCount)))}]
	  set State(gridcol) [expr {$State(gridcnt) / int(sqrt($State(cmdCount)))}]
	}
	row {
	  incr State(gridcol)
	}
	column {
	  if {[string first family $widgetName] < 0} {
	    incr State(gridcol)
	  } else {
	    set colspan 6
	    set State(gridcol) 1
  	    incr State(gridrow)
	  }
	}
	default  {
	  tk_messageBox -type ok -message "INVALID: $State(controlStyle)"
	  return -code -1
	}
      }
      incr State(gridcnt)

puts "    grid $widgetName -sticky ew -row $State(gridrow)  -column $State(gridcol) -columnspan $colspan"

    grid $widgetName -sticky ew -row $State(gridrow) \
        -column $State(gridcol) -columnspan $colspan
    if {[string first family $widgetName] >= 0} {
      set State(gridrow) 0
      set  State(gridcol) 4
    }
  }

################################################################
#   method keyRelease {key}--
#    Process a key release event
# Arguments
#   key	value of key
# 
# Results
#   Tag locations are modified.
# 
  method keyRelease {key} {
    variable State

    update idle
    set end [$State(textWin) index insert]
    $State(textWin) tag remove tag_$State(tagNum) $State(rangeStart) $State(rangeEnd)
    $State(textWin) tag add tag_$State(tagNum) $State(rangeStart) $end

    set State(rangeEnd) $end
  }

################################################################
#   method buttonRelease {x y}--
#    Process a button release event
# Arguments
#   x	X location in window
#   y	Y location in window
# Results
#   Resets rangeStart and rangeEnd to move tag locations
# 
  method buttonRelease {x y} {
    variable State
    # puts "BR: $x $y"
    set State(rangeStart) [$State(textWin) index @$x,$y]
    set State(rangeEnd)   [$State(textWin) index @$x,$y]
  }

################################################################
#   method GenerateTagConfig {}--
#    Internal method. Creates tag configure options based on
#    State values
# Arguments
#   NONE
# 
# Results
#   
# 
  method GenerateTagConfig {} {
    variable State
    if {0} {
    # This shouldn't be needed with combbox in -state readonly
    if {$State(fontFamily) eq ""} {
      set State(fontFamily) sans-serif
    }
    if {$State(fontSize) eq ""} {
      set State(fontSize) 12
    }
    }
    set fontFmt "$State(fontFamily) $State(fontSize)"
    set tagFmt "-foreground $State(foreground)"
    if {$State(background) ne "white"} {
      append tagFmt " -background $State(background)"
    }
    $State(colorFontFrame).fg configure -image icon-$State(foreground),16    
    $State(colorFontFrame).bg configure -image icon-$State(background),16    

    dict for {k v} $State(cmdDict) {
      if {$State($k)} {
        if {[llength $v] == 1} {
	  append fontFmt " $v"
	} else {
          append tagFmt " [subst $v]"
	}
      }
    }
    append tagFmt " -font {$fontFmt}"
    # puts "TAGFMT: $tagFmt"
    $State(textWin) tag configure tag_[incr State(tagNum)] {*}$tagFmt
    return tag_$State(tagNum)
  }

################################################################
#   method processSelection {}--
#    If there is a valid "sel" tag in the widget, process that
#    field. This lets you select text and change font, size, color, etc.
# Arguments
#   NONE
# 
# Results
#   May change text display
# 
  method processSelection {} {
    variable State
    set range [$State(textWin) tag range sel]
    # puts "PS: R: $range -- $State(prevRange)"
    if {$State(prevRange) eq $range} {
      $State(textWin) tag remove tag_$State(tagNum) {*}$State(prevRange)
    }
    set tagID [my GenerateTagConfig]

    # puts "    $State(textWin) tag add $tagID {*}$range"
    $State(textWin) tag add $tagID {*}$range
    set State(prevRange) $range
  }

################################################################
#   method setTag {args}--
#    Invoked by callbacks when tag configuration state is changed
# Arguments
#   args	Ignored. Some set by trace or other callbacks.
# 
# Results
#   Changes tag config and tag locations.
# 
  method setTag {args} {
    variable State

    if {[$State(textWin) tag range sel] ne ""} {
      my processSelection
      return
    }
    # my parray
    set tagID [my GenerateTagConfig]
    set insertIndex [$State(textWin) index insert]
    set State(rangeStart) $insertIndex
    set State(rangeEnd)   $insertIndex
    set State(prevRange) ""
  }
  
################################################################
#   method export {}--
#    Export the contents in Tk format
# Arguments
#   NONE
# 
# Results
#   Returns lists describing tags and text
# 
  method export {} {
    variable State
    
    # Get rid of tags that have no range - ones that
    # have been superceded by other tags.

    foreach tagNm [$State(textWin) tag names] {
      if {[$State(textWin) tag range $tagNm] eq ""} {
        $State(textWin) tag delete $tagNm
      }
    }

    # Check for tags that start and stop on the same index.
    # This is legal for Tk. The latter tag overwrites the
    # early one, but not so good for serialized output
    # where the stacking order is lost. The lower tag won't
    # matter, so get rid of it.
    # Can't just use:
    # set tagDump [$State(textWin) dump -tag 1.0 end]
    
    foreach tagNm [$State(textWin) tag names] {
      if {[string first tag $tagNm] < 0} {continue}
      set rng [join [$State(textWin) tag range $tagNm] ,]
      lappend checks($rng) $tagNm
    }

    set tagOffList {}
    foreach index [lsort -dict [array names checks]] {
      if {[llength $checks($index)] > 0} {
        set checks($index) [lindex $checks($index) end]
      }
      set tagNm $checks($index)
      lassign [split $index ,] st end
      lappend tagDump [list tagon $tagNm $st] [list tagoff $tagNm $end]
      lappend tagConf $tagNm [my GetTagConfig $tagNm]
    }
    set tagDump [join [lsort -command "[self] compare" $tagDump]]
    set textDump [$State(textWin) dump -text 1.0 end] 
    set textDump [string map {< &lt; > &gt;} $textDump]
    return [list $tagConf $tagDump $textDump]
  }
  
################################################################
#   method compare {l1 l2}--
#    Compare two tag lists 
#    Return 1 if l1 > l2
#    Return 0 if l1 == l2
#    Return -1 if l1 < l2
# Arguments
#   l1		First list {operation identifier index}
#   l2		Second list
# Results
#   No side effects.
# 
  method compare {l1 l2} {
    return [my cmpIndex [lindex $l1 end] [lindex $l2 end]]
  }

################################################################
#   method cmpIndex {index1 index2}--
#    Compare text indices
# Arguments
#   index1 	text index line.char
#   index2 	text index line.char
# Results
#    Return 1 if l1 > l2
#    Return 0 if l1 == l2
#    Return -1 if l1 < l2
# 
  method cmpIndex {index1 index2} {
    lassign [split $index1 .] l1 c1
    lassign [split $index2 .] l2 c2
    # Compare lines
    if {$l1 > $l2} {
      return 1
    }
    if {$l1 < $l2} {
      return -1
    }
    # If lines are equal, compare char locations
    if {$c1 > $c2} {
      return 1
    }
    if {$c1 < $c2} {
      return -1
    }
    # Must be equal.
    return 0
  }  
################################################################
#   method GetTagConfig {tagNm}--
#    Get significant parts of a tag config. Only config options
#    that aren't default {}
# Arguments
#   tagNm	name of tag to get config options
# 
# Results
#   No side effects
# 
  method GetTagConfig {tagNm} {
    variable State
    set cfg ""
    if {[string first tag $tagNm] == 0} {
      foreach set [$State(textWin) tag configure $tagNm] {
        lassign $set opt a b c d
	if {$d ne ""} {
          lappend cfg $opt $d 
	}
      }
    }
    return $cfg
  }

################################################################
#   method import {dumpData}--
#    import a datastream from "export"
# Arguments
#   dumpData	Data from the equivalent export command
# 
# Results
#   Text widget is modified. Tags are configured, added and text is
# inserted.
# 
  method import {dumpData} {
    variable State
    lassign $dumpData tags tagDump textDump
    # puts "TAGS: $tags"
    # puts "tagDump: $tagDump"
    # puts "textDump: $textDump"
    
    set skips {sel current insert}

    set textDump [string map { &lt; < &gt; >} $textDump]
    foreach {tt txt index} $textDump {
      $State(textWin) insert $index $txt
    }
    foreach {nm config} $tags {
      $State(textWin) tag configure $nm {*}$config
    }

    foreach {op nm index} $tagDump {
      if {[lsearch $skips $nm] >= 0} {continue}
      switch $op {
        tagon {
	  set start($nm) $index
	}
	tagoff {
	  $State(textWin) tag add $nm {*}$start($nm) {*}$index
	}
      }
    }
  }

}
}

if {[info exists argv] && ([string first -testModTOO $argv] >= 0)} {
  lappend auto_path .
  package require formatTextOO

  destroy {*}[winfo children .]
  toplevel .bb
  set obj1 [formatTextBase .txt -controlFrame .bb -fontFamily courier \
      -fontSize 14]
  puts "OBJ: $obj1"
  grid [$obj1 configure -textWin] -columnspan 3
  catch {
    grid [$obj1 configure -controlFrame]
  }
  
  set obj2 [formatTextBase .txt2  -fontFamily courier \
      -fontSize 14 -controlStyle row]
  puts "OBJ2: $obj2"
  grid [$obj2 configure -textWin ] -columnspan 4
  grid [$obj2 configure -controlFrame]  -columnspan 4
  
  button .bb1 -text "Export from top page" -command {set data [$obj1 export]}
  button .bb2 -text "Import into bottom page" -command {$obj2 import $data}

  button .bb3 -text "save ExportData" -command {
    set of [open save.dat w]
    puts $of $data
    close $of
  }
  button .bb4 -text "load ExportData" -command {
    set if [open save.dat r]
    set data [read $if]
    close $if
  }
  grid .bb1 .bb2 .bb3 .bb4
}

