if {[info exists argv] && ([string first -testRTFOO $argv] >= 0)} {
  ::tcl::tm::path add .
}

package require formatTextWin
package require ratsub
package provide formatTextWinRTFSub

oo::class create formatTextWinRTF {
  super formatTextWin
################################################################
#   classmethod unknown {w args}--
#    Handles unknown event
# Arguments
#  w	First argument to unknown. Hopefully a window name
#  args	Everything else
#
# Results
#   If w is a window name, control is passed to class create method
#   and a new widget is created.
# 
  classmethod unknown {w args} {
    if {[string match .* $w]} {
      set newObj [[self] new $w {*}$args]
#      rename $w ${w}_WIN
      return $newObj
    }
    next $w {*}$args
  }

################################################################
#   method export {}--
#    Export the text widget contents as RTF
#    Formatted per
# Arguments
#   fileName - file to be exported to
# 
# Results
#   Creates new file in file system
# 
  method export {} {
    variable State

    rtf::exportTextWinToFile $State(textWin) $State(outputFilename)
  }
}



if {[info exists argv] && ([string first -testRTFOO $argv] >= 0)} {
  ::tcl::tm::path add .
  package require formatTextWin

  
  if {[string first -tktest $argv] >= 0} {
    source ../tktest/socksend/socksend.tcl
    sockappsetup tktest.tcl 3010  127.0.0.1
  }

  destroy {*}[winfo children .]
  toplevel .bb
  set obj1 [formatTextWinRTF .txt -controlFrame .bb -fontFamily courier \
      -fontSize 14]
  puts "OBJ: $obj1"
  grid [$obj1 configure -textWin] -columnspan 4
  catch {
    grid [$obj1 configure -controlFrame]
  }
  
  set obj2 [formatTextWinRTF .txt2  -fontFamily courier \
      -fontSize 14 -controlStyle row]
  puts "OBJ2: $obj2"
  grid [$obj2 configure -textWin ] -columnspan 4
  grid [$obj2 configure -controlFrame]  -columnspan 4
  
  button .bb1 -text "Export from top page" -command {set data [$obj1 export]}
  button .bb2 -text "Import into bottom page" -command {$obj2 import $data}
  button .bb3 -text "save ExportData" -command {
    $obj2 configure -outputFilename test.rtf
    set data [$obj2 export]
    set of [open save.dat w]
    puts $of $data
    close $of
  }
  button .bb4 -text "load ExportData" -command {
    set if [open save.dat r]
    set data [read $if]
    close $if
  }
  grid .bb1 .bb2 .bb3 .bb4

  toplevel .cc
  set obj3 [formatTextWinRTF .txt3  -fontFamily courier -controlFrame .cc\
      -fontSize 14 -controlStyle column]
  puts "obj3: $obj3"
  grid [$obj3 configure -textWin ] -columnspan 4
  
  .txt3 tag configure red -foreground red -font {arial 12}
  .txt3 tag configure redbold -foreground red -font {arial 12 bold}
  .txt3 tag configure normal -font {arial 12}
  .txt3 insert end "This is a normal line\n" normal
  .txt3 insert end "This is red\n" red
  .txt3 insert end "This is red and bold\n" redbold
  $obj3 configure -outputFilename testOutput.rtf
  $obj3 export 
}

